> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update M2M Client

> Update an existing M2M Client using the Stytch API

Use this endpoint to activate or deactivate an M2M Client by changing its `status`. A deactivated M2M Client will not be allowed to perform future token exchange flows until it is reactivated.

<Note>
  Deactivating an M2M Client will not invalidate any existing JWTs issued to the client, only prevent it from receiving new ones. To protect more-sensitive routes, pass a lower `max_token_age` value when [authenticating the token](/api-reference/b2b/api/m2m/token/authenticate-access-token).
</Note>


## OpenAPI

````yaml PUT /v1/m2m/clients/{client_id}
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/m2m/clients/{client_id}:
    put:
      tags:
        - M2M
      summary: Update
      description: >-
        Updates an existing M2M Client. You can use this endpoint to activate or
        deactivate an M2M Client by changing its `status`. A deactivated M2M
        Client will not be allowed to perform future token exchange flows until
        it is reactivated.


        **Important:** Deactivating an M2M Client will not invalidate any
        existing JWTs issued to the client, only prevent it from receiving new
        ones.

        To protect more-sensitive routes, pass a lower `max_token_age` value
        when[authenticating the
        token](https://stytch.com/docs/b2b/api/authenticate-m2m-token)[authenticating
        the token](https://stytch.com/docs/api/authenticate-m2m-token).
      operationId: api_m2m_v1_m2m_clients_Update
      parameters:
        - name: client_id
          in: path
          required: true
          schema:
            type: string
            description: The ID of the client.
          description: The ID of the client.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/api_m2m_v1_m2m_clients_UpdateRequest'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/api_m2m_v1_m2m_clients_UpdateResponse'
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // PUT /v1/m2m/clients/{client_id}
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
              client_name: "My Sample Client",
              client_description: "My sample client for testing out M2M authentication.",
              scopes: ["read:users", "write:users"],
            };

            client.M2M.Clients.Update(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// PUT /v1/m2m/clients/{client_id}\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/b2bstytchapi\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/m2m/clients\"\n)\n\nfunc main() {\n\tclient, err := b2bstytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &clients.UpdateParams{\n\t\tClientID:          \"m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885\",\n\t\tClientName:        \"My Sample Client\",\n\t\tClientDescription: \"My sample client for testing out M2M authentication.\",\n\t\tScopes:            []string{\"read:users\", \"write:users\"},\n\t}\n\n\tresp, err := client.M2M.Clients.Update(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: |-
            // PUT /v1/m2m/clients/{client_id}
            package com.example;

            import com.stytch.java.b2b.StytchB2BClient;
            import com.stytch.java.common.StytchResult;
            import com.stytch.java.consumer.models.m2mclients.UpdateRequest;

            public class Main {
                public static void main(String[] args) {
                    StytchB2BClient.configure("${projectId}", "${secret}");

                    UpdateRequest params = new UpdateRequest();
                    params.setClientId("m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885");
                    params.setClientName("My Sample Client");
                    params.setClientDescription("My sample client for testing out M2M authentication.");
                    params.setScopes(new String("read:users", "write:users"));

                    Object result = StytchB2BClient.getM2M().getClients().update(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: |
            // PUT /v1/m2m/clients/{client_id}
            package com.example

            import com.stytch.java.b2b.StytchB2BClient
            import com.stytch.java.consumer.models.m2mclients.UpdateRequest

            fun main() {
                StytchB2BClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchB2BClient.m2m.clients.update(
                            UpdateRequest(
                                clientId = "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
                                clientName = "My Sample Client",
                                clientDescription = "My sample client for testing out M2M authentication.",
                                scopes = arrayOf("read:users", "write:users"),
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // PUT /v1/m2m/clients/{client_id}
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
              client_name: "My Sample Client",
              client_description: "My sample client for testing out M2M authentication.",
              scopes: ["read:users", "write:users"],
            };

            client.m2m.clients.update(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->m2m->clients->update([
                'client_id' => 'm2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885',
                'client_name' => 'My Sample Client',
                'client_description' => 'My sample client for testing out M2M authentication.',
                'scopes' => ['read:users', 'write:users'],
            ]);
        - lang: python
          label: Python
          source: |
            # PUT /v1/m2m/clients/{client_id}
            from stytch import B2BClient

            client = B2BClient(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.m2m.clients.update(
                client_id="m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
                client_name="My Sample Client",
                client_description="My sample client for testing out M2M authentication.",
                scopes=["read:users", "write:users"],
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # PUT /v1/m2m/clients/{client_id}
            require 'stytch'

            client = StytchB2B::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.m2m.clients.update(
              client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
              client_name: "My Sample Client",
              client_description: "My sample client for testing out M2M authentication.",
              scopes: ['read:users', 'write:users']
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // PUT /v1/m2m/clients/{client_id}
            use stytch::b2b::client::Client;
            use stytch::consumer::m2m_clients::UpdateRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.m2m.clients.update(
                    UpdateRequest{
                        client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
                        client_name: Some(String::from("My Sample Client")),
                        client_description: Some(String::from("My sample client for testing out M2M authentication.")),
                        scopes: vec!["read:users", "write:users"],
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # PUT /v1/m2m/clients/{client_id}
            curl --request PUT \
              --url https://test.stytch.com/v1/m2m/clients/m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885 \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -d '{
                "client_name": "My Sample Client",
                "client_description": "My sample client for testing out M2M authentication.",
                "scopes": ["read:users", "write:users"]
              }'
components:
  schemas:
    api_m2m_v1_m2m_clients_UpdateRequest:
      type: object
      properties:
        client_name:
          type: string
          description: A human-readable name for the client.
        client_description:
          type: string
          description: A human-readable description for the client.
        status:
          $ref: '#/components/schemas/api_m2m_v1_m2m_clients_UpdateRequestStatus'
          description: The status of the client - either `active` or `inactive`.
        scopes:
          type: array
          items:
            type: string
          description: An array of scopes assigned to the client.
        trusted_metadata:
          type: object
          additionalProperties: true
          description: >-
            The `trusted_metadata` field contains an arbitrary JSON object of
            application-specific data. See the
            [Metadata](https://stytch.com/docs/api/metadata) reference for
            complete field behavior details.
      description: Request type
    api_m2m_v1_m2m_clients_UpdateResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        m2m_client:
          $ref: '#/components/schemas/api_m2m_v1_M2MClient'
          description: The M2M Client affected by this operation.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - m2m_client
        - status_code
    api_m2m_v1_m2m_clients_UpdateRequestStatus:
      type: string
      enum:
        - active
        - inactive
    api_m2m_v1_M2MClient:
      type: object
      properties:
        client_id:
          type: string
          description: The ID of the client.
        client_name:
          type: string
          description: A human-readable name for the client.
        client_description:
          type: string
          description: A human-readable description for the client.
        status:
          type: string
          description: The status of the client - either `active` or `inactive`.
        scopes:
          type: array
          items:
            type: string
          description: An array of scopes assigned to the client.
        client_secret_last_four:
          type: string
          description: The last four characters of the client secret.
        trusted_metadata:
          type: object
          additionalProperties: true
          description: An arbitrary JSON object for storing application-specific data.
        next_client_secret_last_four:
          type: string
          description: >-
            The last four characters of the `next_client_secret`. Null if no
            `next_client_secret` exists.
      required:
        - client_id
        - client_name
        - client_description
        - status
        - scopes
        - client_secret_last_four
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````